#ifndef MSP_GL_SIMPLESCENE_H_
#define MSP_GL_SIMPLESCENE_H_

#include <set>
#include "scene.h"

namespace Msp {
namespace GL {

/**
A simple yet efficient scene.  Rendering order is unspecified.
*/
class SimpleScene: public Scene
{
private:
	typedef std::set<Renderable *> RenderableSet;
	typedef std::vector<Renderable *> RenderableArray;

	RenderableSet renderables;
	mutable RenderableArray cache;

public:
	virtual void add(Renderable &);
	virtual void remove(Renderable &);

private:
	void populate_cache() const;

public:
	virtual void setup_frame(Renderer &);
	virtual void finish_frame();

	virtual void render(Renderer &, Tag = Tag()) const;
};

} // namespace GL
} // namespace Msp

#endif
